diff --git a/enrol/authorize/lib.php b/enrol/authorize/lib.php
new file mode 100755
index 0000000..c47d3a8
--- /dev/null
+++ b/enrol/authorize/lib.php
@@ -0,0 +1,803 @@
+<?php
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * Authorize enrolment plugin.
+ *
+ * This plugin allows you to set up paid courses, using authorize.net.
+ *
+ * @package    enrol
+ * @subpackage authorize
+ * @copyright  2010 Eugene Venter
+ * @author     Eugene Venter
+ * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
+defined('MOODLE_INTERNAL') || die();
+
+require_once($CFG->dirroot.'/enrol/authorize/const.php');
+require_once($CFG->dirroot.'/enrol/authorize/localfuncs.php');
+require_once($CFG->dirroot.'/enrol/authorize/authorizenet.class.php');
+require_once($CFG->libdir.'/eventslib.php');
+
+/**
+ * Authorize.net Payment Gateway plugin
+ */
+class enrol_authorize_plugin extends enrol_plugin {
+     /**
+     * Cron log.
+     *
+     * @var string
+     * @access public
+     */
+    public $log;
+
+    public function roles_protected() {
+        // users wit role assign cap may tweak the roles later
+        return false;
+    }
+
+    public function allow_unenrol(stdClass $instance) {
+        // users with unenrol cap may unenrol other users manually - requires enrol/authorize:unenrol
+        return true;
+    }
+
+    public function allow_manage(stdClass $instance) {
+        // users with manage cap may tweak period and status - requires enrol/authorize:manage
+        return true;
+    }
+
+    public function show_enrolme_link(stdClass $instance) {
+        return ($instance->status == ENROL_INSTANCE_ENABLED);
+    }
+
+    /**
+     * Sets up navigation entries.
+     *
+     * @param object $instance
+     * @return void
+     */
+
+    public function add_course_navigation($instancesnode, stdClass $instance) {
+        if ($instance->enrol !== 'authorize') {
+             throw new coding_exception('Invalid enrol instance type!');
+        }
+
+        $context = get_context_instance(CONTEXT_COURSE, $instance->courseid);
+        if (has_capability('enrol/authorize:config', $context)) {
+            $managelink = new moodle_url('/enrol/authorize/edit.php', array('courseid'=>$instance->courseid, 'id'=>$instance->id));
+            $instancesnode->add($this->get_instance_name($instance), $managelink, navigation_node::TYPE_SETTING);
+        }
+    }
+
+    /**
+     * Returns edit icons for the page with list of instances
+     * @param stdClass $instance
+     * @return array
+     */
+    public function get_action_icons(stdClass $instance) {
+        global $OUTPUT;
+
+        if ($instance->enrol !== 'authorize') {
+            throw new coding_exception('invalid enrol instance!');
+        }
+        $context = get_context_instance(CONTEXT_COURSE, $instance->courseid);
+
+        $icons = array();
+
+        if (has_capability('enrol/authorize:config', $context)) {
+            $editlink = new moodle_url("/enrol/authorize/edit.php", array('courseid'=>$instance->courseid, 'id'=>$instance->id));
+            $icons[] = $OUTPUT->action_icon($editlink, new pix_icon('i/edit', get_string('edit'), 'core', array('class'=>'icon')));
+        }
+
+        return $icons;
+    }
+
+    /**
+     * Returns link to page which may be used to add new instance of enrolment plugin in course.
+     * @param int $courseid
+     * @return moodle_url page url
+     */
+
+    public function get_newinstance_link($courseid) {
+        $context = get_context_instance(CONTEXT_COURSE, $courseid, MUST_EXIST);
+
+        if (!has_capability('moodle/course:enrolconfig', $context) or !has_capability('enrol/authorize:config', $context)) {
+            return NULL;
+        }
+
+        // multiple instances supported - different cost for different roles
+        return new moodle_url('/enrol/authorize/edit.php', array('courseid'=>$courseid));
+    }
+
+
+    /**
+     * Presents enrol registration form
+     *
+     * @param stdClass $instance
+     * @return string html text, usually a form in a text box
+     */
+    public function enrol_page_hook(stdClass $instance) {
+        global $CFG, $USER, $OUTPUT, $PAGE, $DB;
+
+
+        if ($DB->record_exists('user_enrolments', array('userid'=>$USER->id, 'enrolid'=>$instance->id))) {
+            return null;
+        }
+
+        if ($instance->enrolstartdate != 0 && $instance->enrolstartdate > time()) {
+            return null;
+        }
+
+        if ($instance->enrolenddate != 0 && $instance->enrolenddate < time()) {
+            return null;
+        }
+
+        $zerocost = zero_cost($instance);
+        if ($zerocost) { // no cost, other enrolment methods (instances) should be used
+            ob_start();
+            echo '<p>'.get_string('nocost', 'enrol_authorize').'</p>';
+
+            return $OUTPUT->box(ob_get_clean());
+        }
+
+        prevent_double_paid($instance);
+
+        // Check https availability
+        if (empty($CFG->loginhttps) and substr($CFG->wwwroot, 0, 5) !== 'https') {
+            ob_start();
+            echo '<p>'.get_string('httpsrequired', 'enrol_authorize').'</p>';
+            return $OUTPUT->box(ob_get_clean());
+        } elseif (isset($_SERVER['SERVER_PORT']) && $_SERVER['SERVER_PORT'] != 443) { // MDL-9836
+            if (empty($CFG->loginhttps)) {
+                ob_start();
+                echo '<p>'.get_string('httpsrequired', 'enrol_authorize').'</p>';
+
+                return $OUTPUT->box(ob_get_clean());
+            } else {
+                $wwwsroot = str_replace('http:','https:', $CFG->wwwroot);
+                redirect("{$wwwsroot}/enrol/index.php?id=$instance->courseid");
+                exit;
+            }
+        }
+
+        $course = $DB->get_record('course', array('id'=>$instance->courseid));
+
+        $strcourses = get_string('courses');
+        $strloginto = get_string('loginto', '', $course->shortname);
+
+        if ($USER->username == 'guest') { // only real guest user, not for users with guest role
+            ob_start();
+            $curcost = get_course_cost($instance);
+            echo '<div class="mdl-align">';
+            echo '<p>'.get_string('paymentrequired').'</p>';
+            echo '<p><b>'.get_string('cost').": {$curcost['currency']} {$curcost['cost']}".'</b></p>';
+            echo '<p><a href="'.$CFG->httpswwwroot.'/login/">'.get_string('loginsite').'</a></p>';
+            echo '</div>';
+
+            return $OUTPUT->box(ob_get_clean());
+        } else {
+            require_once($CFG->dirroot.'/enrol/authorize/enrol_form.php');
+            $form = new enrol_authorize_form(NULL, $instance);
+            if ($data = $form->get_data()) {
+                $authmessage = '';
+                switch ($data->paymentmethod) {
+                    case AN_METHOD_CC:
+                        $authmessage = $this->cc_submit($data, $course, $instance);
+                        break;
+
+                    case AN_METHOD_ECHECK:
+                        $authmessage = $this->echeck_submit($data, $course, $instance);
+                        break;
+                }
+                if (!empty($authmessage)) {
+                    return $OUTPUT->box($authmessage);
+                }
+            }
+
+            ob_start();
+
+            echo '<p><strong>'.get_string('paymentrequired').'</strong></p>';
+            $form->display();
+
+            return $OUTPUT->box(ob_get_clean());
+        }
+    }
+
+    /**
+     * The user submitted credit card form.
+     *
+     * @param object $form Form parameters
+     * @param object $course Course info
+     * @param object $instance Enrol instance
+     * @return string NULL if ok, error message otherwise.
+     * @access private
+     */
+    private function cc_submit($form, $course, $instance) {
+        global $CFG, $USER, $SESSION, $OUTPUT, $DB;
+
+        $plugin = enrol_get_plugin('authorize');
+
+        prevent_double_paid($instance);
+
+        $useripno = getremoteaddr();
+        $curcost = get_course_cost($instance);
+        $exp_date = sprintf("%02d", $form->ccexpiremm) . $form->ccexpireyyyy;
+
+        // NEW CC ORDER
+        $timenow = time();
+        $order = new stdClass();
+        $order->paymentmethod = AN_METHOD_CC;
+        $order->refundinfo = substr($form->cc, -4);
+        $order->ccname = $form->firstname . " " . $form->lastname;
+        $order->courseid = $course->id;
+        $order->instanceid = $form->instanceid;
+        $order->userid = $USER->id;
+        $order->status = AN_STATUS_NONE; // it will be changed...
+        $order->settletime = 0; // cron changes this.
+        $order->transid = 0; // Transaction Id
+        $order->timecreated = $timenow;
+        $order->amount = $curcost['cost'];
+        $order->currency = $curcost['currency'];
+        $order->id = $DB->insert_record("enrol_authorize", $order);
+        if (!$order->id) {
+            message_to_admin("Error while trying to insert new data", $order);
+            return "Insert record error. Admin has been notified!";
+        }
+
+        $extra = new stdClass();
+        $extra->x_card_num = $form->cc;
+        $extra->x_card_code = $form->cvv;
+        $extra->x_exp_date = $exp_date;
+        $extra->x_currency_code = $curcost['currency'];
+        $extra->x_amount = $curcost['cost'];
+        $extra->x_first_name = $form->firstname;
+        $extra->x_last_name = $form->lastname;
+        $extra->x_country = $form->cccountry;
+        $extra->x_address = $form->ccaddress;
+        $extra->x_state = $form->ccstate;
+        $extra->x_city = $form->cccity;
+        $extra->x_zip = $form->cczip;
+
+        $extra->x_invoice_num = $order->id;
+        $extra->x_description = $course->shortname;
+
+        $extra->x_cust_id = $USER->id;
+        $extra->x_email = $USER->email;
+        $extra->x_customer_ip = $useripno;
+        $extra->x_email_customer = $plugin->get_config('enrol_mailstudents') ? 'FALSE' : 'TRUE';
+        $extra->x_phone = '';
+        $extra->x_fax = '';
+
+        if ($plugin->get_config('an_authcode') && !empty($form->ccauthcode)) {
+            $action = AN_ACTION_CAPTURE_ONLY;
+            $extra->x_auth_code = $form->ccauthcode;
+        } elseif ($plugin->get_config('an_review')) {
+            $action = AN_ACTION_AUTH_ONLY;
+        } else {
+            $action = AN_ACTION_AUTH_CAPTURE;
+        }
+
+        $message = '';
+        if (AN_APPROVED == AuthorizeNet::process($order, $message, $extra, $action, $form->cctype)) {
+            $SESSION->ccpaid = 1; // security check: don't duplicate payment
+
+            switch ($action)
+            {
+                // review enabled (authorize but capture: draw money but wait for settlement during 30 days)
+                // the first step is to inform payment managers and to redirect the user to main page.
+                // the next step is to accept/deny payment (AN_ACTION_PRIOR_AUTH_CAPTURE/VOID) within 30 days (payment management or scheduled-capture CRON)
+                // unless you accept payment or enable auto-capture cron, the transaction is expired after 30 days and the user cannot enrol to the course during 30 days.
+                // see also: admin/cron.php, $this->cron(), $plugin->get_config('an_capture_day')...
+                case AN_ACTION_AUTH_ONLY:
+                {
+                    $a = new stdClass;
+                    $a->url = "$CFG->wwwroot/enrol/authorize/index.php?order=$order->id";
+                    $a->orderid = $order->id;
+                    $a->transid = $order->transid;
+                    $a->amount = "$order->currency $order->amount";
+                    $a->expireon = userdate(AuthorizeNet::getsettletime($timenow + (30 * 3600 * 24)));
+                    $a->captureon = userdate(AuthorizeNet::getsettletime($timenow + (intval($plugin->get_config('an_capture_day')) * 3600 * 24)));
+                    $a->course = $course->fullname;
+                    $a->user = fullname($USER);
+                    $a->acstatus = ($plugin->get_config('an_capture_day') > 0) ? get_string('yes') : get_string('no');
+                    $emailmessage = get_string('adminneworder', 'enrol_authorize', $a);
+                    $a = new stdClass;
+                    $a->course = $course->shortname;
+                    $a->orderid = $order->id;
+                    $emailsubject = get_string('adminnewordersubject', 'enrol_authorize', $a);
+                    $context = get_context_instance(CONTEXT_COURSE, $course->id);
+                    if (($paymentmanagers = get_users_by_capability($context, 'enrol/authorize:managepayments'))) {
+                        foreach ($paymentmanagers as $paymentmanager) {
+                            $eventdata = new object();
+                            $eventdata->modulename        = 'moodle';
+                            $eventdata->component         = 'enrol_authorize';
+                            $eventdata->name              = 'authorize_enrolment';
+                            $eventdata->userfrom          = $USER;
+                            $eventdata->userto            = $paymentmanager;
+                            $eventdata->subject           = $emailsubject;
+                            $eventdata->fullmessage       = $emailmessage;
+                            $eventdata->fullmessageformat = FORMAT_PLAIN;
+                            $eventdata->fullmessagehtml   = '';
+                            $eventdata->smallmessage      = '';
+                            message_send($eventdata);
+                        }
+                    }
+                    redirect($CFG->wwwroot, get_string("reviewnotify", "enrol_authorize"), '30');
+                    break;
+                }
+
+                case AN_ACTION_CAPTURE_ONLY: // auth code received via phone and the code accepted.
+                case AN_ACTION_AUTH_CAPTURE: // real time transaction, authorize and capture.
+                {
+                    // Credit card captured, ENROL student now...
+                    if ($instance->enrolperiod) {
+                        $timestart = time();
+                        $timeend   = $timestart + $instance->enrolperiod;
+                    } else {
+                        $timestart = 0;
+                        $timeend   = 0;
+                    }
+
+                    $plugin->enrol_user($instance, $USER->id, $instance->roleid, $timestart, $timeend);
+
+                    // Send notifications
+                    if ($plugin->get_config('enrol_mailstudents')) {
+                        send_welcome_messages($order->id);
+                    }
+                    if ($plugin->get_config('enrol_mailteachers')) {
+                        $context = get_context_instance(CONTEXT_COURSE, $course->id);
+                        $paymentmanagers = get_users_by_capability($context, 'enrol/authorize:managepayments', '', '', '0', '1');
+                        $paymentmanager = array_shift($paymentmanagers);
+                        $a = new stdClass;
+                        $a->course = "$course->fullname";
+                        $a->user = fullname($USER);
+
+                        $eventdata = new object();
+                        $eventdata->modulename        = 'moodle';
+                        $eventdata->component         = 'enrol_authorize';
+                        $eventdata->name              = 'authorize_enrolment';
+                        $eventdata->userfrom          = $USER;
+                        $eventdata->userto            = $paymentmanager;
+                        $eventdata->subject           = get_string("enrolmentnew", '', format_string($course->shortname));
+                        $eventdata->fullmessage       = get_string('enrolmentnewuser', '', $a);
+                        $eventdata->fullmessageformat = FORMAT_PLAIN;
+                        $eventdata->fullmessagehtml   = '';
+                        $eventdata->smallmessage      = '';
+                        message_send($eventdata);
+                    }
+                    if ($plugin->get_config('enrol_mailadmins')) {
+                        $a = new stdClass;
+                        $a->course = "$course->fullname";
+                        $a->user = fullname($USER);
+                        $admins = get_admins();
+                        foreach ($admins as $admin) {
+                            $eventdata = new object();
+                            $eventdata->modulename  = 'moodle';
+                            $eventdata->component   = 'enrol_authorize';
+                            $eventdata->name        = 'authorize_enrolment';
+                            $eventdata->userfrom    = $USER;
+                            $eventdata->userto      = $admin;
+                            $eventdata->subject     = get_string("enrolmentnew", '', format_string($course->shortname));
+                            $eventdata->fullmessage = get_string('enrolmentnewuser', '', $a);
+                            $eventdata->fullmessageformat = FORMAT_PLAIN;
+                            $eventdata->fullmessagehtml   = '';
+                            $eventdata->smallmessage      = '';
+                            message_send($eventdata);
+                        }
+                    }
+
+                    load_all_capabilities();
+
+                    echo $OUTPUT->header();
+                    echo $OUTPUT->box_start('generalbox notice');
+                    echo '<p>'. get_string('paymentthanks', 'moodle', $course->fullname) .'</p>';
+                    echo $OUTPUT->container_start('buttons');
+                    echo $OUTPUT->single_button(new moodle_url("$CFG->wwwroot/enrol/authorize/index.php", array('order'=>$order->id)), get_string('payments'));
+                    echo $OUTPUT->single_button(new moodle_url("$CFG->wwwroot/course/view.php", array('id'=>$course->id)), $course->fullname);
+                    echo $OUTPUT->container_end();
+                    echo $OUTPUT->box_end();
+                    echo $OUTPUT->footer();
+                    exit;  // show output now!
+                }
+            }
+            return NULL;
+        } else {
+            message_to_admin($message, $order);
+            return $message;
+        }
+    }
+
+    /**
+     * The user submitted echeck form.
+     *
+     * @param object $form Form parameters
+     * @param object $course Course info
+     * @param object $course Enrol instance
+     * @return string NULL if ok, error message otherwise.
+     * @access private
+     */
+    private function echeck_submit($form, $course, $instance)
+    {
+        global $CFG, $USER, $SESSION, $DB;
+
+        prevent_double_paid($instance);
+
+        $useripno = getremoteaddr();
+        $curcost = get_course_cost($instance);
+        $isbusinesschecking = ($form->acctype == 'BUSINESSCHECKING');
+
+        // NEW ECHECK ORDER
+        $timenow = time();
+        $order = new stdClass();
+        $order->paymentmethod = AN_METHOD_ECHECK;
+        $order->refundinfo = $isbusinesschecking ? 1 : 0;
+        $order->ccname = $form->firstname . ' ' . $form->lastname;
+        $order->courseid = $course->id;
+        $order->instanceid = $form->instanceid;
+        $order->userid = $USER->id;
+        $order->status = AN_STATUS_NONE; // it will be changed...
+        $order->settletime = 0; // cron changes this.
+        $order->transid = 0; // Transaction Id
+        $order->timecreated = $timenow;
+        $order->amount = $curcost['cost'];
+        $order->currency = $curcost['currency'];
+        $order->id = $DB->insert_record("enrol_authorize", $order);
+        if (!$order->id) {
+            message_to_admin("Error while trying to insert new data", $order);
+            return "Insert record error. Admin has been notified!";
+        }
+
+        $extra = new stdClass();
+        $extra->x_bank_aba_code = $form->abacode;
+        $extra->x_bank_acct_num = $form->accnum;
+        $extra->x_bank_acct_type = $form->acctype;
+        $extra->x_echeck_type = $isbusinesschecking ? 'CCD' : 'WEB';
+        $extra->x_bank_name = $form->bankname;
+        $extra->x_currency_code = $curcost['currency'];
+        $extra->x_amount = $curcost['cost'];
+        $extra->x_first_name = $form->firstname;
+        $extra->x_last_name = $form->lastname;
+        $extra->x_country = $USER->country;
+        $extra->x_address = $USER->address;
+        $extra->x_city = $USER->city;
+        $extra->x_state = '';
+        $extra->x_zip = '';
+
+        $extra->x_invoice_num = $order->id;
+        $extra->x_description = $course->shortname;
+
+        $extra->x_cust_id = $USER->id;
+        $extra->x_email = $USER->email;
+        $extra->x_customer_ip = $useripno;
+        $extra->x_email_customer = $plugin->get_config('enrol_mailstudents') ? 'TRUE' : 'FALSE';
+        $extra->x_phone = '';
+        $extra->x_fax = '';
+
+        $message = '';
+        if (AN_REVIEW == AuthorizeNet::process($order, $message, $extra, AN_ACTION_AUTH_CAPTURE)) {
+            $SESSION->ccpaid = 1; // security check: don't duplicate payment
+            redirect($CFG->wwwroot, get_string("reviewnotify", "enrol_authorize"), '30');
+            return NULL;
+        }
+        else {
+            message_to_admin($message, $order);
+            return $message;
+        }
+    }
+
+    /**
+     * This function is run by admin/cron.php every time if admin has enabled this plugin.
+     *
+     * Everyday at settlement time (default is 00:05), it cleans up some tables
+     * and sends email to admin/teachers about pending orders expiring if manual-capture has enabled.
+     *
+     * If admin set up 'Order review' and 'Capture day', it captures credits cards and enrols students.
+     *
+     * @access public
+     */
+    public function cron()
+    {
+        global $CFG, $DB;
+
+        $oneday = 86400;
+        $timenow = time();
+        $settlementtime = AuthorizeNet::getsettletime($timenow);
+        $timediff30 = $settlementtime - (30 * $oneday);
+        $mconfig = get_config('enrol_authorize');
+        $plugin = enrol_get_plugin('authorize');
+
+        mtrace("Processing authorize cron...");
+
+        if (!isset($mconfig->an_dailysettlement) || intval($mconfig->an_dailysettlement) < $settlementtime) {
+            set_config('an_dailysettlement', $settlementtime, 'enrol_authorize');
+            mtrace("    Daily cron:");
+            $this->cron_daily();
+            mtrace("    Done");
+        }
+
+        mtrace("    Scheduled capture", ": ");
+        if (!$mconfig->an_review or ($mconfig->an_test) or (intval($mconfig->an_capture_day) < 1) or (!check_curl_available())) {
+            mtrace("disabled");
+            return; // order review disabled or test mode or manual capture or openssl wasn't loaded.
+        }
+
+        $timediffcnf = $settlementtime - (intval($mconfig->an_capture_day) * $oneday);
+        $select = "(status = ?) AND (timecreated < ?) AND (timecreated > ?)";
+        $params = array(AN_STATUS_AUTH, $timediffcnf, $timediff30);
+        if (!($ordercount = $DB->count_records_select('enrol_authorize', $select, $params))) {
+            mtrace("no pending orders");
+            return;
+        }
+
+        $eachconn = intval($mconfig->an_eachconnsecs);
+        $eachconn = (($eachconn > 60) ? 60 : (($eachconn <= 0) ? 3 : $eachconn));
+        if (($ordercount * $eachconn) + intval($mconfig->an_lastcron) > $timenow) {
+            mtrace("blocked");
+            return;
+        }
+        set_config('an_lastcron', $timenow, 'enrol_authorize');
+
+        mtrace("    $ordercount orders are being processed now", ": ");
+
+        $faults = '';
+        $sendem = array();
+        $elapsed = time();
+        @set_time_limit(0);
+        $this->log = "AUTHORIZE.NET AUTOCAPTURE CRON: " . userdate($timenow) . "\n";
+
+        $lastcourseid = 0;
+        $rs = $DB->get_recordset_select('enrol_authorize', $select, $params, 'courseid');
+        foreach ( $rs as $order)
+        {
+            $message = '';
+            $extra = NULL;
+            if (AN_APPROVED == AuthorizeNet::process($order, $message, $extra, AN_ACTION_PRIOR_AUTH_CAPTURE)) {
+                if ($lastcourseid != $order->courseid) {
+                    $lastcourseid = $order->courseid;
+                    $course = $DB->get_record('course', array('id'=>$lastcourseid));
+                    $role = get_default_course_role($course);
+                    $context = get_context_instance(CONTEXT_COURSE, $lastcourseid);
+                }
+                $timestart = $timeend = 0;
+                if ($course->enrolperiod) {
+                    $timestart = $timenow;
+                    $timeend = $order->settletime + $course->enrolperiod;
+                }
+                $user = $DB->get_record('user', array('id'=>$order->userid));
+                $pinstance = $DB->get_record('enrol', array('id'=>$order->instanceid));
+                $plugin->enrol_user($pinstance, $order->userid, $pinstance->roleid, $timestart, $timeend);
+                $this->log .= "User($user->id) has been enrolled to course($course->id).\n";
+                if (!empty($mconfig->enrol_mailstudents)) {
+                    $sendem[] = $order->id;
+                }
+            } else {
+                $this->log .= "Error, Order# $order->id: " . $message . "\n";
+            }
+        }
+        $rs->close();
+        mtrace("processed");
+
+        $timenow = time();
+        $elapsed = $timenow - $elapsed;
+        $eachconn = ceil($elapsed / $ordercount);
+        set_config('an_eachconnsecs', $eachconn, 'enrol_authorize');
+
+        $this->log .= "AUTHORIZE.NET CRON FINISHED: " . userdate($timenow);
+
+        $adminuser = get_admin();
+        if (!empty($faults)) {
+            $eventdata = new object();
+            $eventdata->modulename        = 'moodle';
+            $eventdata->component         = 'enrol_authorize';
+            $eventdata->name              = 'authorize_enrolment';
+            $eventdata->userfrom          = $adminuser;
+            $eventdata->userto            = $adminuser;
+            $eventdata->subject           = "AUTHORIZE.NET CRON FAULTS";
+            $eventdata->fullmessage       = $faults;
+            $eventdata->fullmessageformat = FORMAT_PLAIN;
+            $eventdata->fullmessagehtml   = '';
+            $eventdata->smallmessage      = '';
+            message_send($eventdata);
+        }
+        if (!empty($mconfig->enrol_mailadmins)) {
+            $eventdata = new object();
+            $eventdata->modulename        = 'moodle';
+            $eventdata->component         = 'enrol_authorize';
+            $eventdata->name              = 'authorize_enrolment';
+            $eventdata->userfrom          = $adminuser;
+            $eventdata->userto            = $adminuser;
+            $eventdata->subject           = "AUTHORIZE.NET CRON LOG";
+            $eventdata->fullmessage       = $this->log;
+            $eventdata->fullmessageformat = FORMAT_PLAIN;
+            $eventdata->fullmessagehtml   = '';
+            $eventdata->smallmessage      = '';
+            message_send($eventdata);
+        }
+
+        // Send emails to students about which courses have enrolled.
+        if (!empty($sendem)) {
+            mtrace("    sending welcome messages to students", ": ");
+            send_welcome_messages($sendem);
+            mtrace("sent");
+        }
+    }
+
+    /**
+     * Daily cron. It executes at settlement time (default is 00:05).
+     *
+     * @access private
+     */
+    private function cron_daily()
+    {
+        global $CFG, $SITE, $DB;
+
+        $mconfig = get_config('enrol_authorize');
+
+        $oneday = 86400;
+        $timenow = time();
+        $onepass = $timenow - $oneday;
+        $settlementtime = AuthorizeNet::getsettletime($timenow);
+        $timediff30 = $settlementtime - (30 * $oneday);
+
+        $select = "(status=?) AND (timecreated<?)";
+        $params = array(AN_STATUS_NONE, $timediff30);
+        if ($DB->delete_records_select('enrol_authorize', $select, $params)) {
+            mtrace("        orders no transaction made have deleted");
+        }
+
+        $select = "(status=?) AND (timecreated<?)";
+        $params = array(AN_STATUS_EXPIRE, AN_STATUS_AUTH, $timediff30);
+        if ($DB->execute("UPDATE {enrol_authorize} SET status=? WHERE $select", $params)) {
+            mtrace("        pending orders to expire have updated");
+        }
+
+        $timediff60 = $settlementtime - (60 * $oneday);
+        $select = "(status=?) AND (timecreated<?)";
+        $params = array(AN_STATUS_EXPIRE, $timediff60);
+        if ($DB->delete_records_select('enrol_authorize', $select, $params)) {
+            mtrace("        orders expired older than 60 days have deleted");
+        }
+
+        $adminuser = get_admin();
+        $select = "status IN(?,?) AND (timecreated<?) AND (timecreated>?)";
+        $params = array(AN_STATUS_UNDERREVIEW, AN_STATUS_APPROVEDREVIEW, $onepass, $timediff60);
+        if (($count = $DB->count_records_select('enrol_authorize', $select, $params)) &&
+            ($csvusers = get_users_by_capability(get_context_instance(CONTEXT_SYSTEM), 'enrol/authorize:uploadcsv'))) {
+            $a = new stdClass;
+            $a->count = $count;
+            $a->course = $SITE->shortname;
+            $subject = get_string('pendingechecksubject', 'enrol_authorize', $a);
+            $a = new stdClass;
+            $a->count = $count;
+            $a->url = $CFG->wwwroot.'/enrol/authorize/uploadcsv.php';
+            $message = get_string('pendingecheckemail', 'enrol_authorize', $a);
+            foreach($csvusers as $csvuser) {
+                $eventdata = new object();
+                $eventdata->modulename        = 'moodle';
+                $eventdata->component         = 'enrol_authorize';
+                $eventdata->name              = 'authorize_enrolment';
+                $eventdata->userfrom          = $adminuser;
+                $eventdata->userto            = $csvuser;
+                $eventdata->subject           = $subject;
+                $eventdata->fullmessage       = $message;
+                $eventdata->fullmessageformat = FORMAT_PLAIN;
+                $eventdata->fullmessagehtml   = '';
+                $eventdata->smallmessage      = '';
+                message_send($eventdata);
+            }
+            mtrace("        users who have 'enrol/authorize:uploadcsv' were mailed");
+        }
+
+        mtrace("        early pending order warning email for manual capture", ": ");
+        if (empty($mconfig->an_emailexpired)) {
+            mtrace("not enabled");
+            return;
+        }
+
+
+        $timediffem = $settlementtime - ((30 - intval($mconfig->an_emailexpired)) * $oneday);
+        $select = "(status=?) AND (timecreated<?) AND (timecreated>?)";
+        $params = array(AN_STATUS_AUTH, $timediffem, $timediff30);
+        $count = $DB->count_records_select('enrol_authorize', $select, $params);
+        if (!$count) {
+            mtrace("no orders prior to {$mconfig->an_emailexpired} days");
+            return;
+        }
+
+        mtrace("$count orders prior to {$mconfig->an_emailexpired} days");
+        $a = new stdClass;
+        $a->pending = $count;
+        $a->days = $mconfig->an_emailexpired;
+        $a->course = $SITE->shortname;
+        $subject = get_string('pendingorderssubject', 'enrol_authorize', $a);
+        $a = new stdClass;
+        $a->pending = $count;
+        $a->days = $mconfig->an_emailexpired;
+        $a->course = $SITE->fullname;
+        $a->enrolurl = "$CFG->wwwroot/$CFG->admin/enrol_config.php?enrol=authorize";
+        $a->url = $CFG->wwwroot.'/enrol/authorize/index.php?status='.AN_STATUS_AUTH;
+        $message = get_string('pendingordersemail', 'enrol_authorize', $a);
+
+        $eventdata = new object();
+        $eventdata->modulename        = 'moodle';
+        $eventdata->component         = 'enrol_authorize';
+        $eventdata->name              = 'authorize_enrolment';
+        $eventdata->userfrom          = $adminuser;
+        $eventdata->userto            = $adminuser;
+        $eventdata->subject           = $subject;
+        $eventdata->fullmessage       = $message;
+        $eventdata->fullmessageformat = FORMAT_PLAIN;
+        $eventdata->fullmessagehtml   = '';
+        $eventdata->smallmessage      = '';
+        message_send($eventdata);
+
+        // Email to payment managers
+        if (empty($mconfig->an_emailexpiredteacher)) {
+            return; // email feature disabled for teachers.
+        }
+
+        $sorttype = empty($mconfig->an_sorttype) ? 'ttl' : $mconfig->an_sorttype;
+        $sql = "SELECT e.courseid, e.currency, c.fullname, c.shortname,
+                  COUNT(e.courseid) AS cnt, SUM(e.amount) as ttl
+                FROM {enrol_authorize} e
+                  INNER JOIN {course} c ON c.id = e.courseid
+                WHERE (e.status = ?)
+                  AND (e.timecreated < ?)
+                  AND (e.timecreated > ?)
+                GROUP BY e.courseid
+                ORDER BY $sorttype DESC";
+        $params = array(AN_STATUS_AUTH, $timediffem, $timediff30);
+
+        $rs = $DB->get_recordset_sql($sql, $params);
+        foreach ($rs as $courseinfo)
+        {
+            $lastcourse = $courseinfo->courseid;
+            $context = get_context_instance(CONTEXT_COURSE, $lastcourse);
+            if (($paymentmanagers = get_users_by_capability($context, 'enrol/authorize:managepayments'))) {
+                $a = new stdClass;
+                $a->course = $courseinfo->shortname;
+                $a->pending = $courseinfo->cnt;
+                $a->days = $mconfig->an_emailexpired;
+                $subject = get_string('pendingorderssubject', 'enrol_authorize', $a);
+                $a = new stdClass;
+                $a->course = $courseinfo->fullname;
+                $a->pending = $courseinfo->cnt;
+                $a->currency = $courseinfo->currency;
+                $a->sumcost = $courseinfo->ttl;
+                $a->days = $mconfig->an_emailexpired;
+                $a->url = $CFG->wwwroot.'/enrol/authorize/index.php?course='.$lastcourse.'&amp;status='.AN_STATUS_AUTH;
+                $message = get_string('pendingordersemailteacher', 'enrol_authorize', $a);
+                foreach ($paymentmanagers as $paymentmanager) {
+                    $eventdata = new object();
+                    $eventdata->modulename        = 'moodle';
+                    $eventdata->component         = 'enrol_authorize';
+                    $eventdata->name              = 'authorize_enrolment';
+                    $eventdata->userfrom          = $adminuser;
+                    $eventdata->userto            = $paymentmanager;
+                    $eventdata->subject           = $subject;
+                    $eventdata->fullmessage       = $message;
+                    $eventdata->fullmessageformat = FORMAT_PLAIN;
+                    $eventdata->fullmessagehtml   = '';
+                    $eventdata->smallmessage      = '';
+                    message_send($eventdata);
+                }
+            }
+        }
+        $rs->close();
+    }
+}
+
